<?php
namespace Bushelpowered\Api\Platform\Connection\V1;

use \Bushelpowered\Api\Platform\Connection\V1\Request\UpdateBlacklistRequest;
use \Bushelpowered\Api\Platform\Connection\V1\Response\UpdateBlacklistResponse;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bushelpowered\Api\Common\NotAuthorized;
use \Bushelpowered\Api\Common\ConstraintViolation;
use \Bidl\Php\Core\Builtins\UnknownError;

class UpdateBlacklist 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    public function call(UpdateBlacklistRequest $request, $headers): UpdateBlacklistResponse | NotAuthenticated | NotAuthorized | ConstraintViolation | UnknownError
    {
         return $this->client->call('api/platform/connection/v1/UpdateBlacklist', $request, $this->getWrapper(), $headers);
    }
    
    private function getWrapper() {
        return new class () implements \Bidl\Php\Core\BidlResponse {

            /** @var UpdateBlacklistResponse | NotAuthenticated | NotAuthorized | ConstraintViolation | UnknownError */
            public $response;
        
            public function __construct()
            {
                $this->mapper = new \JsonMapper();
            }
            
            public function fromJson($data) 
            {
                switch($data->type) {
                  case 'api.platform.connection.v1#UpdateBlacklistSuccess':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Platform\Connection\V1\Response\UpdateBlacklistResponse::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthenticated':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthorized':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthorized::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#ConstraintViolation':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\ConstraintViolation::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                   default: 
                     $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
                }
            }
        };
    }
}