<?php
namespace Bushelpowered\Api\Platform\Subscription\V1\Model;
        
class SubscriptionStandard implements \Bushelpowered\Api\Common\HasTimestamps
{
    public string $id;
    public string $tenantId;
    public ?string $userId = null;
    public ?string $accountId = null;
    public string $featureId;
    public string $consumerId;
    public string $consumerTargetId;
    public ?bool $isSubscribed = null;
    /** @var string $createdAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var string $updatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;
    /** @var null|string $deletedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $deletedAt = null;

    /**
     * @param  string  $createdAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $updatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $deletedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $id, string $tenantId, ?string $userId, ?string $accountId, string $featureId, string $consumerId, string $consumerTargetId, ?bool $isSubscribed, string $createdAt, string $updatedAt, ?string $deletedAt)
    {
        $this->id = $id;
        $this->tenantId = $tenantId;
        $this->userId = $userId;
        $this->accountId = $accountId;
        $this->featureId = $featureId;
        $this->consumerId = $consumerId;
        $this->consumerTargetId = $consumerTargetId;
        $this->isSubscribed = $isSubscribed;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
        $this->deletedAt = $deletedAt;
    }
    
    /**
     * @return string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
    /**
     * @return string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getUpdatedAt(): string
    {
        return $this->updatedAt;
    }
    /**
     * @return null|string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getDeletedAt(): ?string
    {
        return $this->deletedAt;
    }
}